__author__  = 'Tom-Wilkin Martinussen <tom@oberon.no>'

from AccessControl import ClassSecurityInfo, AuthEncoding

from zope.interface import implements

from Products.CMFCore import permissions
from AccessControl import getSecurityManager, ClassSecurityInfo
from Products.Archetypes.interfaces.orderedfolder import IOrderedFolder
from Products.ATContentTypes.atct import ATFolder, ATFolderSchema
from Products.ATContentTypes.atct import ATCTContent, ATContentTypeSchema
from config import *
from Products.ATContentTypes.configuration import zconf
from Products.Archetypes.public import registerType
from Products.Archetypes.public import DisplayList
from Products.CMFCore.utils import getToolByName


try:
	from Products.LinguaPlone.public import *
except ImportError:
	# No multilingual support
	from Products.Archetypes.public import *

schema  = ATContentTypeSchema.copy() + Schema((

          StringField('Score',
		    searchable=0,
		    required=True,
		    default='plone',
            vocabulary=DisplayList((('1', u'1 of 6'),
                                    ('2', u'2 of 6'),
                                    ('3', u'3 of 6'),
                                    ('4', u'4 of 6'),
                                    ('5', u'5 of 6'),
                                    ('6', u'6 of 6'),)),
            widget=SelectionWidget(label=u'Score',
		                           description="Select score for this element",
                				   format='select'),
			),
			
			TextField('body',
		            searchable = 1,
		            required = False,
		            allowable_content_types = ('text/plain',
		                                       'text/structured',
		                                       'text/html',),
		            default_output_type = 'text/x-html-safe',
		            widget = RichWidget(label = 'Full description'),
		           ),

          ),

)

schema['description'].widget.visible = False
schema['relatedItems'].widget.visible = False

class Element(ATCTContent):
    """ Bedrift archetype """
    
    schema = schema
    
    meta_type = archetype_name = portal_type = 'Element'
    content_icon = 'star_icon.gif'
    _at_rename_after_creation = True
    global_allow = 0
    immediate_view = 'base_view'
    default_view = 'base_view'

    
    actions = ({
        'id': 'view',
        'name': 'View',
        'action': 'string:${object_url}/base_view',
        'permissions': (permissions.View,)
        },{
        'id': 'edit',
        'name': 'Edit',
        'action': 'string:${object_url}/base_edit',
        'permissions': (permissions.ViewManagementScreens,)
        },{
        'id': 'metadata',
        'name': 'Properties',
        'action': 'string:${object_url}/base_metadata',
        'permissions': (permissions.ViewManagementScreens,)
        },)
        
    def at_post_edit_script(self, **kwargs):
        """ After edit, update Partner Members Property """
        self.aq_parent.reindexObject()

    def at_post_create_script(self, **kwargs):
        """ After edit, update Partner Members Property """
        self.aq_parent.reindexObject()

##
# Folder contents actionen ville ikke overstyres herfra.
# Har derfor endret tillatelse paa denne actionene via ZMI.
# Dette maa enten fikses her, eller ZMI settingen maa inn i Install.py
#
#        {
#        'id': 'folderContents',
#        'name': 'Contents',
#        'action': 'string:${object_url}/folder_contents',
#        'permissions': (CMFCorePermissions.ViewManagementScreens,)
#        },)
        
registerType(Element, PROJECTNAME)
